#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{

    [Description("Enter the description of your new custom indicator here")]
    public class RSI60MINFilterInd : Indicator
    {
        #region Variables
 
            private int period = 14; 
		
// Internas
		
		
    
        #endregion


        protected override void Initialize()
        {
            Add(new Plot(Color.FromKnownColor(KnownColor.Red), PlotStyle.Line, "Plot0"));
	
			Plots[0].Pen.Width=2;
            Overlay	= 	false;
			Add(PeriodType.Minute,60);
			
        }


        protected override void OnBarUpdate()
        {
			
		if (CurrentBar < period)	return;
	
		Plot0.Set(RSI(BarsArray[1],period,3)[0]);
			
        }

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Plot0
        {
            get { return Values[0]; }
        }
		[Description("")]
        [Category("Parameters")]
        public int Period
        {
            get { return period; }
            set { period = Math.Max(1, value); }
        }
		
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private RSI60MINFilterInd[] cacheRSI60MINFilterInd = null;

        private static RSI60MINFilterInd checkRSI60MINFilterInd = new RSI60MINFilterInd();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public RSI60MINFilterInd RSI60MINFilterInd(int period)
        {
            return RSI60MINFilterInd(Input, period);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public RSI60MINFilterInd RSI60MINFilterInd(Data.IDataSeries input, int period)
        {
            if (cacheRSI60MINFilterInd != null)
                for (int idx = 0; idx < cacheRSI60MINFilterInd.Length; idx++)
                    if (cacheRSI60MINFilterInd[idx].Period == period && cacheRSI60MINFilterInd[idx].EqualsInput(input))
                        return cacheRSI60MINFilterInd[idx];

            lock (checkRSI60MINFilterInd)
            {
                checkRSI60MINFilterInd.Period = period;
                period = checkRSI60MINFilterInd.Period;

                if (cacheRSI60MINFilterInd != null)
                    for (int idx = 0; idx < cacheRSI60MINFilterInd.Length; idx++)
                        if (cacheRSI60MINFilterInd[idx].Period == period && cacheRSI60MINFilterInd[idx].EqualsInput(input))
                            return cacheRSI60MINFilterInd[idx];

                RSI60MINFilterInd indicator = new RSI60MINFilterInd();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                RSI60MINFilterInd[] tmp = new RSI60MINFilterInd[cacheRSI60MINFilterInd == null ? 1 : cacheRSI60MINFilterInd.Length + 1];
                if (cacheRSI60MINFilterInd != null)
                    cacheRSI60MINFilterInd.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheRSI60MINFilterInd = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.RSI60MINFilterInd RSI60MINFilterInd(int period)
        {
            return _indicator.RSI60MINFilterInd(Input, period);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.RSI60MINFilterInd RSI60MINFilterInd(Data.IDataSeries input, int period)
        {
            return _indicator.RSI60MINFilterInd(input, period);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.RSI60MINFilterInd RSI60MINFilterInd(int period)
        {
            return _indicator.RSI60MINFilterInd(Input, period);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.RSI60MINFilterInd RSI60MINFilterInd(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.RSI60MINFilterInd(input, period);
        }
    }
}
#endregion
